GridFire 0.0.1a General Purpose Nuclear Network

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
gridfire::solver::QSENetworkSolver::RHSFunctor Struct Reference

Functor for calculating the right-hand side of the ODEs for the dynamic species. More...

## Public Member Functions
| RHSFunctor (DynamicEngine &engine, const std::vector< size_t > &dynamicSpeciesIndices, const std::vector< size_t > &QSESpeciesIndices, const Eigen::VectorXd &Y_QSE, const double T9, const double rho)
| Constructor for the RHSFunctor.
void | operator() (const boost::numeric::ublas::vector< double > &YDynamic, boost::numeric::ublas::vector< double > &dYdtDynamic, double t) const
| Calculates the time derivatives of the dynamic species.

## Public Attributes
DynamicEngine & | m_engine
| The engine used to evaluate the network.
const std::vector< size_t > & | m_dynamicSpeciesIndices
| Indices of the dynamic species.
const std::vector< size_t > & | m_QSESpeciesIndices
| Indices of the QSE species.
const Eigen::VectorXd & | m_Y_QSE
| Steady-state abundances of the QSE species.
const double | m_T9
| Temperature in units of 10^9 K.
const double | m_rho
| Density in g/cm^3.
bool | m_isViewInitialized = false

## Detailed Description

Functor for calculating the right-hand side of the ODEs for the dynamic species.

This functor is used by the ODE solver to calculate the time derivatives of the dynamic species. It takes the current abundances of the dynamic species as input and returns the time derivatives of those abundances.

Definition at line 201 of file solver.h.

## Constructor & Destructor Documentation

## ◆ RHSFunctor()

gridfire::solver::QSENetworkSolver::RHSFunctor::RHSFunctor | ( | DynamicEngine & | engine,
|  | const std::vector< size_t > & | dynamicSpeciesIndices,
|  | const std::vector< size_t > & | QSESpeciesIndices,
|  | const Eigen::VectorXd & | Y_QSE,
|  | const double | T9,
|  | const double | rho )
| inline

Constructor for the RHSFunctor.

Parameters

  engine | The engine used to evaluate the network.
  dynamicSpeciesIndices | Indices of the dynamic species.
  QSESpeciesIndices | Indices of the QSE species.
  Y_QSE | Steady-state abundances of the QSE species.
  T9 | Temperature in units of 10^9 K.
  rho | Density in g/cm^3.

Definition at line 220 of file solver.h.

## Member Function Documentation

## ◆ operator()()

void gridfire::solver::QSENetworkSolver::RHSFunctor::operator() | ( | const boost::numeric::ublas::vector< double > & | YDynamic,
|  | boost::numeric::ublas::vector< double > & | dYdtDynamic,
|  | double | t ) const

Calculates the time derivatives of the dynamic species.

Parameters

  YDynamic | Vector of current abundances for the dynamic species.
  dYdtDynamic | Vector to store the time derivatives of the dynamic species.
  t | Current time.

Definition at line 350 of file solver.cpp.

## Member Data Documentation

## ◆ m_dynamicSpeciesIndices

const std::vector<size_t>& gridfire::solver::QSENetworkSolver::RHSFunctor::m_dynamicSpeciesIndices

Indices of the dynamic species.

Definition at line 203 of file solver.h.

## ◆ m_engine

DynamicEngine& gridfire::solver::QSENetworkSolver::RHSFunctor::m_engine

The engine used to evaluate the network.

Definition at line 202 of file solver.h.

## ◆ m_isViewInitialized

bool gridfire::solver::QSENetworkSolver::RHSFunctor::m_isViewInitialized = false

Definition at line 209 of file solver.h.

## ◆ m_QSESpeciesIndices

const std::vector<size_t>& gridfire::solver::QSENetworkSolver::RHSFunctor::m_QSESpeciesIndices

Indices of the QSE species.

Definition at line 204 of file solver.h.

## ◆ m_rho

const double gridfire::solver::QSENetworkSolver::RHSFunctor::m_rho

Density in g/cm^3.

Definition at line 207 of file solver.h.

## ◆ m_T9

const double gridfire::solver::QSENetworkSolver::RHSFunctor::m_T9

Temperature in units of 10^9 K.

Definition at line 206 of file solver.h.

## ◆ m_Y_QSE

const Eigen::VectorXd& gridfire::solver::QSENetworkSolver::RHSFunctor::m_Y_QSE

Steady-state abundances of the QSE species.

Definition at line 205 of file solver.h.

The documentation for this struct was generated from the following files:

- src/network/include/gridfire/solver/solver.h
- src/network/lib/solver/solver.cpp